## sqlitebrowser 3.10.1

=== CMakeLists.txt ===
project(sqlitebrowser)
cmake_minimum_required(VERSION 2.8.7)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

OPTION(ENABLE_TESTING "Enable the unit tests" OFF)
OPTION(FORCE_INTERNAL_ANTLR "Don't use the distribution's Antlr library even if there is one" OFF)
OPTION(FORCE_INTERNAL_QSCINTILLA "Don't use the distribution's QScintilla library even if there is one" OFF)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
endif()

add_definitions(-std=c++11)

if(WIN32 AND MSVC)
	project("DB Browser for SQLite")
	if(CMAKE_CL_64)
		# Paths for 64-bit windows builds
		set(OPENSSL_PATH "C:/dev/OpenSSL-Win64")
		set(QT5_PATH "C:/dev/Qt/5.7/msvc2013_64")
		set(VSREDIST "vcredist_x64.exe")

                # Choose between SQLCipher or SQLite, depending whether
                # -Dsqlcipher=1 is passed on the command line
                if(sqlcipher)
                        set(SQLITE3_PATH "C:/git_repos/SQLCipher-Win64")
                else()
                        set(SQLITE3_PATH "C:/dev/SQLite-Win64")
                endif()
	else()
		# Paths for 32-bit windows builds
		set(OPENSSL_PATH "C:/dev/OpenSSL-Win32")
		set(QT5_PATH "C:/dev/Qt/5.7/msvc2013")
		set(VSREDIST "vcredist_x86.exe")

                # Choose between SQLCipher or SQLite, depending whether
                # -Dsqlcipher=1 is passed on the command line
                if(sqlcipher)
                        set(SQLITE3_PATH "C:/git_repos/SQLCipher-Win32")
                else()
                        set(SQLITE3_PATH "C:/dev/SQLite-Win32")
                endif()
	endif()
	set(CMAKE_PREFIX_PATH "${QT5_PATH};${SQLITE3_PATH}")
	set(VSREDIST_DIR "C:/dev/dependencies")
endif()

if(NOT FORCE_INTERNAL_ANTLR)
    find_package(Antlr2)
endif()
if(NOT FORCE_INTERNAL_QSCINTILLA)
    find_package(QScintilla)
endif()

set(QHEXEDIT_DIR libs/qhexedit)
set(QCUSTOMPLOT_DIR libs/qcustomplot-source)

if(NOT ANTLR2_FOUND)
    set(ANTLR_DIR libs/antlr-2.7.7)
    add_subdirectory(${ANTLR_DIR})
endif()
if(NOT QSCINTILLA_FOUND)
    set(QSCINTILLA_DIR libs/qscintilla/Qt4Qt5)
    add_subdirectory(${QSCINTILLA_DIR})
endif()
add_subdirectory(${QHEXEDIT_DIR})
add_subdirectory(${QCUSTOMPLOT_DIR})

find_package(Qt5Widgets REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Network REQUIRED)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(ENABLE_TESTING)
    enable_testing()
endif()

set(SQLB_HDR
	src/version.h
	src/sqlitetypes.h
	src/csvparser.h
	src/sqlite.h
	src/grammar/sqlite3TokenTypes.hpp
	src/grammar/Sqlite3Lexer.hpp
	src/grammar/Sqlite3Parser.hpp
)

set(SQLB_MOC_HDR
	src/sqlitedb.h
	src/AboutDialog.h
	src/EditIndexDialog.h
	src/EditDialog.h
	src/EditTableDialog.h
	src/ExportDataDialog.h
	src/ExtendedTableWidget.h
	src/FilterTableHeader.h
	src/ImportCsvDialog.h
	src/MainWindow.h
	src/Settings.h
	src/PreferencesDialog.h
	src/SqlExecutionArea.h
	src/VacuumDialog.h
	src/sqlitetablemodel.h
	src/sqltextedit.h
	src/DbStructureModel.h
	src/Application.h
	src/CipherDialog.h
	src/ExportSqlDialog.h
	src/SqlUiLexer.h
	src/FileDialog.h
	src/ColumnDisplayFormatDialog.h
	src/FilterLineEdit.h
	src/RemoteDatabase.h
	src/ForeignKeyEditorDelegate.h
	src/PlotDock.h
	src/RemoteDock.h
	src/RemoteModel.h
	src/RemotePushDialog.h
)

set(SQLB_SRC
	src/AboutDialog.cpp
	src/EditIndexDialog.cpp
	src/EditDialog.cpp
	src/EditTableDialog.cpp
	src/ExportDataDialog.cpp
	src/ExtendedTableWidget.cpp
	src/FilterTableHeader.cpp
	src/ImportCsvDialog.cpp
	src/MainWindow.cpp
	src/Settings.cpp
	src/PreferencesDialog.cpp
	src/SqlExecutionArea.cpp
	src/VacuumDialog.cpp
	src/sqlitedb.cpp
	src/sqlitetablemodel.cpp
	src/sqlitetypes.cpp
	src/sqltextedit.cpp
	src/csvparser.cpp
	src/DbStructureModel.cpp
	src/grammar/Sqlite3Lexer.cpp
	src/grammar/Sqlite3Parser.cpp
	src/main.cpp
	src/Application.cpp
	src/CipherDialog.cpp
	src/ExportSqlDialog.cpp
	src/SqlUiLexer.cpp
	src/FileDialog.cpp
	src/ColumnDisplayFormatDialog.cpp
	src/FilterLineEdit.cpp
	src/RemoteDatabase.cpp
	src/ForeignKeyEditorDelegate.cpp
	src/PlotDock.cpp
	src/RemoteDock.cpp
	src/RemoteModel.cpp
	src/RemotePushDialog.cpp
)

set(SQLB_FORMS
	src/AboutDialog.ui
	src/EditIndexDialog.ui
	src/EditDialog.ui
	src/EditTableDialog.ui
	src/ExportDataDialog.ui
	src/ImportCsvDialog.ui
	src/MainWindow.ui
	src/PreferencesDialog.ui
	src/SqlExecutionArea.ui
	src/VacuumDialog.ui
	src/CipherDialog.ui
	src/ExportSqlDialog.ui
	src/ColumnDisplayFormatDialog.ui
	src/PlotDock.ui
	src/RemoteDock.ui
	src/RemotePushDialog.ui
)

set(SQLB_RESOURCES
	src/icons/icons.qrc
	src/translations/flags/flags.qrc
	src/translations/translations.qrc
	src/certs/CaCerts.qrc
)

set(SQLB_MISC
    src/grammar/sqlite3.g
)

# Translation files
set(SQLB_TSS
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_ar_SA.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_cs.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_zh.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_zh_TW.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_de.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_es_ES.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_fr.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_ru.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_pt_BR.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_en_GB.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_ko_KR.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_tr.ts"
	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_uk_UA.ts"
)


qt5_wrap_ui(SQLB_FORM_HDR ${SQLB_FORMS})
if(SQLB_TSS)
	# add translations
	foreach(SQLB_TS ${SQLB_TSS})
		SET_SOURCE_FILES_PROPERTIES("${SQLB_TS}" PROPERTIES OUTPUT_LOCATION "${CMAKE_SOURCE_DIR}/src/translations")
	endforeach(SQLB_TS ${SQLB_TSS})
	qt5_add_translation(SQLB_QMS ${SQLB_TSS})
endif(SQLB_TSS)
qt5_add_resources(SQLB_RESOURCES_RCC ${SQLB_RESOURCES})

#icon and correct libs/subsystem for windows
if(WIN32)
        #enable version check for windows
        add_definitions(-DCHECKNEWVERSION)

	IF( MINGW )
	# resource compilation for MinGW
		ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sqlbicon.o"
			COMMAND windres "-I${CMAKE_CURRENT_SOURCE_DIR}" "-i${CMAKE_CURRENT_SOURCE_DIR}/src/winapp.rc" -o "${CMAKE_CURRENT_BINARY_DIR}/sqlbicon.o" VERBATIM)
		set(SQLB_SRC ${SQLB_SRC} "${CMAKE_CURRENT_BINARY_DIR}/sqlbicon.o")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-subsystem,windows")
		set(WIN32_STATIC_LINK -Wl,-Bstatic -lssl -lcrypto -lws2_32)
		set(ADDITIONAL_LIBS lzma)
	ELSE( MINGW )
		set(SQLB_SRC ${SQLB_SRC} "${CMAKE_CURRENT_SOURCE_DIR}/src/winapp.rc")
	ENDIF( MINGW )
endif(WIN32)

#enable version check for MacOS
if(APPLE)
	add_definitions(-DCHECKNEWVERSION)
endif(APPLE)

# SQLCipher option
if(sqlcipher)
	add_definitions(-DENABLE_SQLCIPHER)
	set(LIBSQLITE_NAME sqlcipher)
else(sqlcipher)
	set(LIBSQLITE_NAME sqlite3)
endif(sqlcipher)

# add extra library path for MacOS and FreeBSD
set(EXTRAPATH APPLE OR ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
if(EXTRAPATH)
	find_library(LIBSQLITE ${LIBSQLITE_NAME} HINTS /usr/local/lib /usr/local/opt/sqlite/lib)
	set(ADDITIONAL_INCLUDE_PATHS /usr/local/include /usr/local/opt/sqlite/include)
else(EXTRAPATH)
	find_library(LIBSQLITE ${LIBSQLITE_NAME})
endif(EXTRAPATH)

if(WIN32 AND MSVC)
	find_path(SQLITE3_INCLUDE_DIR sqlite3.h)
	if(sqlcipher)
		find_file(SQLITE3_DLL sqlcipher.dll)
	else(sqlcipher)
		find_file(SQLITE3_DLL sqlite3.dll)
	endif(sqlcipher)
	include_directories(${SQLITE3_INCLUDE_DIR})
endif()

include_directories(
		"${CMAKE_CURRENT_BINARY_DIR}"
		${QHEXEDIT_DIR}
		${QCUSTOMPLOT_DIR}
		${ADDITIONAL_INCLUDE_PATHS}
		src)
if(ANTLR2_FOUND)
    include_directories(${ANTLR2_INCLUDE_DIRS})
else()
    include_directories(${ANTLR_DIR})
endif()
if(QSCINTILLA_FOUND)
    include_directories(${QSCINTILLA_INCLUDE_DIR})
else()
    include_directories(${QSCINTILLA_DIR})
endif()

add_executable(${PROJECT_NAME}
		${SQLB_HDR}
		${SQLB_SRC}
		${SQLB_FORM_HDR}
		${SQLB_MOC}
		${SQLB_RESOURCES_RCC}
		${SQLB_MISC})

qt5_use_modules(${PROJECT_NAME} Gui Widgets Network Test PrintSupport)
set(QT_LIBRARIES "")

add_dependencies(${PROJECT_NAME} qhexedit qcustomplot)
if(NOT ANTLR2_FOUND)
    add_dependencies(${PROJECT_NAME} antlr)
endif()
if(NOT QSCINTILLA_FOUND)
    add_dependencies(${PROJECT_NAME} qscintilla2)
endif()

link_directories(
	"${CMAKE_CURRENT_BINARY_DIR}/${QHEXEDIT_DIR}"
	"${CMAKE_CURRENT_BINARY_DIR}/${QCUSTOMPLOT_DIR}"
)
if(NOT ANTLR2_FOUND)
    link_directories("${CMAKE_CURRENT_BINARY_DIR}/${ANTLR_DIR}")
endif()
if(NOT QSCINTILLA_FOUND)
    link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
endif()

target_link_libraries(${PROJECT_NAME}
		qhexedit
		qcustomplot
		${QT_LIBRARIES}
		${WIN32_STATIC_LINK}
		${LIBSQLITE}
		${ADDITIONAL_LIBS})
if(ANTLR2_FOUND)
    target_link_libraries(${PROJECT_NAME} ${ANTLR2_LIBRARIES})
else()
    target_link_libraries(${PROJECT_NAME} antlr)
endif()
if(QSCINTILLA_FOUND)
    target_link_libraries(${PROJECT_NAME} ${QSCINTILLA_LIBRARIES})
else()
    target_link_libraries(${PROJECT_NAME} qscintilla2)
endif()

if(WIN32 AND MSVC)
	set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_DEBUG "/SUBSYSTEM:CONSOLE")
	set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_DEFINITIONS_DEBUG "_CONSOLE")
	set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELWITHDEBINFO "/SUBSYSTEM:CONSOLE")
	set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_DEFINITIONS_RELWITHDEBINFO "_CONSOLE")
    if(CMAKE_CL_64)
        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS,5.02 /ENTRY:mainCRTStartup")
        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:WINDOWS,5.02")
    else()
        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS,5.01 /ENTRY:mainCRTStartup")
        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:WINDOWS,5.01")
    endif()
endif()

if(NOT WIN32)
	install(TARGETS ${PROJECT_NAME}
		RUNTIME DESTINATION bin
		LIBRARY DESTINATION lib)
endif()

if(ENABLE_TESTING)
	add_subdirectory(src/tests)
endif()

if(UNIX AND NOT APPLE)
	install(FILES src/icons/${PROJECT_NAME}.png
		DESTINATION share/icons/hicolor/256x256/apps/)
	
	install(FILES distri/${PROJECT_NAME}.desktop
		DESTINATION share/applications/)

	install(FILES distri/${PROJECT_NAME}.desktop.appdata.xml
		DESTINATION share/appdata/)
endif(UNIX AND NOT APPLE)

if(WIN32 AND MSVC)
	install(TARGETS ${PROJECT_NAME}
		RUNTIME DESTINATION "/"
		LIBRARY DESTINATION lib)

	set(QT5_BIN_PATH ${QT5_PATH}/bin)
	# The Qt5 Debug configuration library files have a 'd' postfix
	install(FILES
			${QT5_BIN_PATH}/Qt5Cored.dll
			${QT5_BIN_PATH}/Qt5Guid.dll
			${QT5_BIN_PATH}/Qt5Networkd.dll
			${QT5_BIN_PATH}/Qt5PrintSupportd.dll
			${QT5_BIN_PATH}/Qt5Widgetsd.dll
		DESTINATION "/"
		CONFIGURATIONS Debug)
	# The Qt5 Release configuration files don't have a postfix
	install(FILES
			${QT5_BIN_PATH}/Qt5Core.dll
			${QT5_BIN_PATH}/Qt5Gui.dll
			${QT5_BIN_PATH}/Qt5Network.dll
			${QT5_BIN_PATH}/Qt5PrintSupport.dll
			${QT5_BIN_PATH}/Qt5Widgets.dll
		DESTINATION "/"
		CONFIGURATIONS Release)
	# The files below are common to all configurations
	install(FILES
			${SQLITE3_DLL}
			${OPENSSL_PATH}/libeay32.dll
			${OPENSSL_PATH}/ssleay32.dll
		DESTINATION "/")
	install(FILES
		${QT5_PATH}/plugins/platforms/qwindows.dll
		DESTINATION platforms)
	install(PROGRAMS "${VSREDIST_DIR}/${VSREDIST}" DESTINATION redist)
	# The batch file launcher
	install(FILES
			distri/winlaunch.bat
		DESTINATION "/")
endif()

#cpack
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "DB Browser for SQLite")
set(CPACK_PACKAGE_VENDOR "DB Browser for SQLite Team")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_VERSION_MAJOR "3")
set(CPACK_PACKAGE_VERSION_MINOR "10")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "DB Browser for SQLite")
if(WIN32 AND NOT UNIX)

=== libs/qcustomplot-source/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
find_package(Qt5Widgets REQUIRED)

set(QCUSTOMPLOT_SRC
	qcustomplot.cpp
)

set(QCUSTOMPLOT_HDR
)

set(QCUSTOMPLOT_MOC_HDR
	qcustomplot.h
)

add_library(qcustomplot ${QCUSTOMPLOT_SRC} ${QCUSTOMPLOT_HDR} ${QCUSTOMPLOT_MOC})

qt5_use_modules(qcustomplot Widgets PrintSupport)

=== libs/qhexedit/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
find_package(Qt5Widgets REQUIRED)

set(QHEXEDIT_SRC
    src/qhexedit.cpp
    src/chunks.cpp
    src/commands.cpp
)

set(QHEXEDIT_HDR
    src/chunks.h
    src/commands.h
)

set(QHEXEDIT_MOC_HDR
	src/qhexedit.h
	src/commands.h
)

add_library(qhexedit ${QHEXEDIT_SRC} ${QHEXEDIT_HDR} ${QHEXEDIT_MOC})

qt5_use_modules(qhexedit Widgets)

=== src/tests/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_BINARY_DIR}" ..)

# test-sqlobjects

set(TESTSQLOBJECTS_SRC
    ../sqlitedb.cpp
    ../sqlitetablemodel.cpp
    ../sqlitetypes.cpp
    ../csvparser.cpp
    ../grammar/Sqlite3Lexer.cpp
    ../grammar/Sqlite3Parser.cpp
    ../Settings.cpp
    testsqlobjects.cpp
)

set(TESTSQLOBJECTS_HDR
    ../grammar/sqlite3TokenTypes.hpp
    ../grammar/Sqlite3Lexer.hpp
    ../grammar/Sqlite3Parser.hpp
    ../sqlitetypes.h
)

set(TESTSQLOBJECTS_MOC_HDR
    ../sqlitedb.h
    ../sqlitetablemodel.h
    ../Settings.h
    testsqlobjects.h
)

if(sqlcipher)
    list(APPEND TESTSQLOBJECTS_SRC ../CipherDialog.cpp)
    list(APPEND TESTSQLOBJECTS_FORMS ../CipherDialog.ui)
    list(APPEND TESTSQLOBJECTS_MOC_HDR ../CipherDialog.h)
endif()

QT5_WRAP_UI(TESTSQLOBJECTS_FORM_HDR ${TESTSQLOBJECTS_FORMS})

add_executable(test-sqlobjects ${TESTSQLOBJECTS_MOC} ${TESTSQLOBJECTS_HDR} ${TESTSQLOBJECTS_SRC} ${TESTSQLOBJECTS_FORM_HDR})

qt5_use_modules(test-sqlobjects Test Widgets Gui)
set(QT_LIBRARIES "")

if(NOT ANTLR2_FOUND)
    add_dependencies(test-sqlobjects antlr)
endif()
target_link_libraries(test-sqlobjects ${QT_LIBRARIES} ${LIBSQLITE})
if(ANTLR2_FOUND)
    target_link_libraries(test-sqlobjects ${ANTLR2_LIBRARIES})
else()
    target_link_libraries(test-sqlobjects antlr)
endif()
link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
add_dependencies(test-sqlobjects qscintilla2)
target_link_libraries(test-sqlobjects qscintilla2)
add_test(test-sqlobjects test-sqlobjects)

# test-import

set(TESTIMPORT_SRC
    ../csvparser.cpp
    TestImport.cpp
)

set(TESTIMPORT_MOC_HDR
    TestImport.h
)

add_executable(test-import ${TESTIMPORT_MOC} ${TESTIMPORT_SRC})

qt5_use_modules(test-import Test Core)
set(QT_LIBRARIES "")

target_link_libraries(test-import ${QT_LIBRARIES})
add_test(test-import test-import)

# test regex

set(TESTREGEX_SRC
    ../sqlitedb.cpp
    ../sqlitetablemodel.cpp
    ../sqlitetypes.cpp
    ../grammar/Sqlite3Lexer.cpp
    ../grammar/Sqlite3Parser.cpp
    ../Settings.cpp
    TestRegex.cpp
)

set(TESTREGEX_HDR
    ../grammar/sqlite3TokenTypes.hpp
    ../grammar/Sqlite3Lexer.hpp
    ../grammar/Sqlite3Parser.hpp
    ../sqlitetypes.h
)

set(TESTREGEX_MOC_HDR
    ../sqlitedb.h
    ../sqlitetablemodel.h
    ../Settings.h
    TestRegex.h
)

if(sqlcipher)
    list(APPEND TESTREGEX_SRC ../CipherDialog.cpp)
    list(APPEND TESTREGEX_MOC_HDR ../CipherDialog.h)
endif()

add_executable(test-regex ${TESTREGEX_MOC} ${TESTREGEX_HDR} ${TESTREGEX_SRC})

qt5_use_modules(test-regex Test Core Gui Widgets)
set(QT_LIBRARIES "")

if(NOT ANTLR2_FOUND)
    add_dependencies(test-regex antlr)
endif()
target_link_libraries(test-regex ${QT_LIBRARIES} ${LIBSQLITE})
if(ANTLR2_FOUND)
    target_link_libraries(test-regex ${ANTLR2_LIBRARIES})
else()
    target_link_libraries(test-regex antlr)
endif()
link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
add_dependencies(test-regex qscintilla2)
target_link_libraries(test-regex qscintilla2)
add_test(test-regex test-regex)

=== libs/qscintilla/Qt4Qt5/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
find_package(Qt5Widgets REQUIRED)

if(APPLE)
    find_package(Qt5MacExtras)
endif()

add_definitions(-DSCINTILLA_QT)
add_definitions(-DSCI_LEXER)

set(QSCINTILLA_SRC
	qsciscintilla.cpp
	qsciscintillabase.cpp
	qsciabstractapis.cpp
	qsciapis.cpp
	qscicommand.cpp
	qscicommandset.cpp
	qscidocument.cpp
	qscilexer.cpp
	qscilexercustom.cpp
	qscilexersql.cpp
	qscimacro.cpp
	qsciprinter.cpp
	qscistyle.cpp
	qscistyledtext.cpp
	MacPasteboardMime.cpp
	InputMethod.cpp
	SciClasses.cpp
	ListBoxQt.cpp
	PlatQt.cpp
	ScintillaQt.cpp
	../lexers/LexSQL.cpp
	../lexlib/Accessor.cpp
	../lexlib/CharacterCategory.cpp
	../lexlib/CharacterSet.cpp
	../lexlib/LexerBase.cpp
	../lexlib/LexerModule.cpp
	../lexlib/LexerNoExceptions.cpp
	../lexlib/LexerSimple.cpp
	../lexlib/PropSetSimple.cpp
	../lexlib/StyleContext.cpp
	../lexlib/WordList.cpp
	../src/AutoComplete.cpp
	../src/CallTip.cpp
	../src/CaseConvert.cpp
	../src/CaseFolder.cpp
	../src/Catalogue.cpp
	../src/CellBuffer.cpp
	../src/CharClassify.cpp
	../src/ContractionState.cpp
	../src/Decoration.cpp
	../src/Document.cpp
	../src/Editor.cpp
	../src/EditModel.cpp
	../src/EditView.cpp
	../src/ExternalLexer.cpp
	../src/Indicator.cpp
	../src/KeyMap.cpp
	../src/LineMarker.cpp
	../src/MarginView.cpp
	../src/PerLine.cpp
	../src/PositionCache.cpp
	../src/RESearch.cpp
	../src/RunStyles.cpp
	../src/ScintillaBase.cpp
	../src/Selection.cpp
	../src/Style.cpp
	../src/UniConversion.cpp
	../src/ViewStyle.cpp
	../src/XPM.cpp
)

set(QSCINTILLA_HDR
	./Qsci/qsciglobal.h
	./Qsci/qscicommand.h
	./Qsci/qscicommandset.h
	./Qsci/qscidocument.h
	./Qsci/qsciprinter.h
	./Qsci/qscistyle.h
	./Qsci/qscistyledtext.h
	ListBoxQt.h
	SciNamespace.h
	../include/ILexer.h
	../include/Platform.h
	../include/SciLexer.h
	../include/Scintilla.h
	../include/ScintillaWidget.h
	../include/Sci_Position.h
	../lexlib/Accessor.h
	../lexlib/CharacterCategory.h
	../lexlib/CharacterSet.h
	../lexlib/LexAccessor.h
	../lexlib/LexerBase.h
	../lexlib/LexerModule.h
	../lexlib/LexerNoExceptions.h
	../lexlib/LexerSimple.h
	../lexlib/OptionSet.h
	../lexlib/PropSetSimple.h
	../lexlib/StyleContext.h
	../lexlib/SubStyles.h
	../lexlib/WordList.h
	../src/AutoComplete.h
	../src/CallTip.h
	../src/CaseConvert.h
	../src/CaseFolder.h
	../src/Catalogue.h
	../src/CellBuffer.h
	../src/CharClassify.h
	../src/ContractionState.h
	../src/Decoration.h
	../src/Document.h
	../src/Editor.h
	../src/ExternalLexer.h
	../src/FontQuality.h
	../src/Indicator.h
	../src/KeyMap.h
	../src/LineMarker.h
	../src/Partitioning.h
	../src/PerLine.h
	../src/PositionCache.h
	../src/RESearch.h
	../src/RunStyles.h
	../src/ScintillaBase.h
	../src/Selection.h
	../src/SplitVector.h
	../src/Style.h
	../src/UnicodeFromUTF8.h
	../src/UniConversion.h
	../src/ViewStyle.h
	../src/XPM.h
	../src/Position.h
	../src/SparseVector.h
)

set(QSCINTILLA_MOC_HDR
	./Qsci/qsciscintilla.h
	./Qsci/qsciscintillabase.h
	./Qsci/qsciabstractapis.h
	./Qsci/qsciapis.h
	./Qsci/qscilexer.h
	./Qsci/qscilexercustom.h
	./Qsci/qscilexersql.h
	./Qsci/qscimacro.h
	SciClasses.h
	ScintillaQt.h
)

include_directories(. ../include ../lexlib ../src)

add_library(qscintilla2 ${QSCINTILLA_SRC} ${QSCINTILLA_HDR} ${QSCINTILLA_MOC_HDR} ${QSCINTILLA_MOC})

if (APPLE)
	qt5_use_modules(qscintilla2 Widgets PrintSupport MacExtras)
else()
	qt5_use_modules(qscintilla2 Widgets PrintSupport)
endif()

=== debian/changelog ===
sqlitebrowser (3.10.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update for new qscintilla2 library names (Closes: #885635)

 -- Scott Kitterman <scott@kitterman.com>  Thu, 04 Jan 2018 07:02:20 -0500

sqlitebrowser (3.10.1-1) unstable; urgency=medium

  * New upstream version
  * Upstream has fixed plots involving dates (Closes: #826878)
  * Remove previous patches, add a new patch to use system qscintilla2
  * Change priority to optional and bump Standards-Version
  * Apply upstream patch to avoid focus issues with gnome shell
    (Closes: #879926)

 -- Arto Jantunen <viiru@debian.org>  Sat, 04 Nov 2017 13:55:35 +0200

=== debian/control ===
Source: sqlitebrowser
Section: database
Priority: optional
Maintainer: Arto Jantunen <viiru@debian.org>
Build-Depends: debhelper (>= 10), qtbase5-dev, libsqlite3-dev, cmake, libantlr-dev, qttools5-dev, qttools5-dev-tools, libqscintilla2-qt5-dev
Standards-Version: 4.1.1
Homepage: http://sqlitebrowser.org/
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/sqlitebrowser.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/sqlitebrowser.git

Package: sqlitebrowser
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI editor for SQLite databases
 SQLite Database Browser is a visual tool used to create, design and edit
 database files compatible with SQLite. Its interface is based on QT,
 and is meant to be used for users and developers that want to create
 databases, edit and search data using a familiar spreadsheet-like
 interface, without the need to learn complicated SQL commands.
 Controls and wizards are available for users to:
  - Create and compact database files
  - Create, define, modify and delete tables
  - Create, define and delete indexes
  - Browse, edit, add and delete records
  - Search records
  - Import and export records as text
  - Import and export tables from/to CSV files
  - Import and export databases from/to SQL dump files
  - Issue SQL queries and inspect the results
  - Examine a log of all SQL commands issued by the application
 .
 SQLite Database Browser is not a visual shell for the sqlite command line
 tool. It does not require familiarity with SQL commands.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel 

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTING=True -DQSCINTILLA_INCLUDE_DIR=/usr/include/x86_64-linux-gnu/qt5/Qsci/

## sqlitebrowser 3.11.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,16 @@
 project(sqlitebrowser)
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 2.8.12.2)
+
+# BUILD_VERSION is the current date in YYYYMMDD format. It is only
+# used by the nightly version to add the date of the build.
+string(TIMESTAMP BUILD_VERSION "%Y%m%d")
+
+# Choose between building a stable version or nightly (the default), depending
+# on whether '-DBUILD_STABLE_VERSION=1' is passed on the command line or not.
+option(BUILD_STABLE_VERSION "Don't build the stable version by default" OFF)
+if(NOT BUILD_STABLE_VERSION)
+    add_definitions(-DBUILD_VERSION=${BUILD_VERSION})
+endif()
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
 
@@ -12,14 +23,19 @@
 endif()
 
 add_definitions(-std=c++11)
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED True)
+
+# Fix behavior of CMAKE_CXX_STANDARD when targeting macOS.
+if (POLICY CMP0025)
+    cmake_policy(SET CMP0025 NEW)
+endif ()
 
 if(WIN32 AND MSVC)
-	project("DB Browser for SQLite")
 	if(CMAKE_CL_64)
 		# Paths for 64-bit windows builds
 		set(OPENSSL_PATH "C:/dev/OpenSSL-Win64")
-		set(QT5_PATH "C:/dev/Qt/5.7/msvc2013_64")
-		set(VSREDIST "vcredist_x64.exe")
+		set(QT5_PATH "C:/dev/Qt/5.11.3/msvc2017_64")
 
                 # Choose between SQLCipher or SQLite, depending whether
                 # -Dsqlcipher=1 is passed on the command line
@@ -31,8 +47,7 @@
 	else()
 		# Paths for 32-bit windows builds
 		set(OPENSSL_PATH "C:/dev/OpenSSL-Win32")
-		set(QT5_PATH "C:/dev/Qt/5.7/msvc2013")
-		set(VSREDIST "vcredist_x86.exe")
+		set(QT5_PATH "C:/dev/Qt/5.7/msvc2015")
 
                 # Choose between SQLCipher or SQLite, depending whether
                 # -Dsqlcipher=1 is passed on the command line
@@ -43,14 +58,13 @@
                 endif()
 	endif()
 	set(CMAKE_PREFIX_PATH "${QT5_PATH};${SQLITE3_PATH}")
-	set(VSREDIST_DIR "C:/dev/dependencies")
 endif()
 
 if(NOT FORCE_INTERNAL_ANTLR)
-    find_package(Antlr2)
+    find_package(Antlr2 QUIET)
 endif()
 if(NOT FORCE_INTERNAL_QSCINTILLA)
-    find_package(QScintilla)
+    find_package(QScintilla QUIET)
 endif()
 
 set(QHEXEDIT_DIR libs/qhexedit)
@@ -67,9 +81,8 @@
 add_subdirectory(${QHEXEDIT_DIR})
 add_subdirectory(${QCUSTOMPLOT_DIR})
 
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5LinguistTools REQUIRED)
-find_package(Qt5Network REQUIRED)
+find_package(Qt5 REQUIRED COMPONENTS Concurrent Gui LinguistTools Network PrintSupport Test Widgets Xml)
+
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
@@ -85,6 +98,7 @@
 	src/grammar/sqlite3TokenTypes.hpp
 	src/grammar/Sqlite3Lexer.hpp
 	src/grammar/Sqlite3Parser.hpp
+	src/Data.h
 )
 
 set(SQLB_MOC_HDR
@@ -93,6 +107,7 @@
 	src/EditIndexDialog.h
 	src/EditDialog.h
 	src/EditTableDialog.h
+	src/AddRecordDialog.h
 	src/ExportDataDialog.h
 	src/ExtendedTableWidget.h
 	src/FilterTableHeader.h
@@ -103,7 +118,10 @@
 	src/SqlExecutionArea.h
 	src/VacuumDialog.h
 	src/sqlitetablemodel.h
+	src/RowLoader.h
+	src/RowCache.h
 	src/sqltextedit.h
+	src/docktextedit.h
 	src/DbStructureModel.h
 	src/Application.h
 	src/CipherDialog.h
@@ -118,6 +136,11 @@
 	src/RemoteDock.h
 	src/RemoteModel.h
 	src/RemotePushDialog.h
+	src/FindReplaceDialog.h
+	src/ExtendedScintilla.h
+	src/FileExtensionManager.h
+	src/CipherSettings.h
+	src/DotenvFormat.h
 )
 
 set(SQLB_SRC
@@ -125,6 +148,7 @@
 	src/EditIndexDialog.cpp
 	src/EditDialog.cpp
 	src/EditTableDialog.cpp
+	src/AddRecordDialog.cpp
 	src/ExportDataDialog.cpp
 	src/ExtendedTableWidget.cpp
 	src/FilterTableHeader.cpp
@@ -136,8 +160,10 @@
 	src/VacuumDialog.cpp
 	src/sqlitedb.cpp
 	src/sqlitetablemodel.cpp
+	src/RowLoader.cpp
 	src/sqlitetypes.cpp
 	src/sqltextedit.cpp
+	src/docktextedit.cpp
 	src/csvparser.cpp
 	src/DbStructureModel.cpp
 	src/grammar/Sqlite3Lexer.cpp
@@ -156,6 +182,12 @@
 	src/RemoteDock.cpp
 	src/RemoteModel.cpp
 	src/RemotePushDialog.cpp
+	src/FindReplaceDialog.cpp
+	src/ExtendedScintilla.cpp
+	src/FileExtensionManager.cpp
+	src/Data.cpp
+	src/CipherSettings.cpp
+	src/DotenvFormat.cpp
 )
 
 set(SQLB_FORMS
@@ -163,6 +195,7 @@
 	src/EditIndexDialog.ui
 	src/EditDialog.ui
 	src/EditTableDialog.ui
+	src/AddRecordDialog.ui
 	src/ExportDataDialog.ui
 	src/ImportCsvDialog.ui
 	src/MainWindow.ui
@@ -175,6 +208,8 @@
 	src/PlotDock.ui
 	src/RemoteDock.ui
 	src/RemotePushDialog.ui
+	src/FindReplaceDialog.ui
+	src/FileExtensionManager.ui
 )
 
 set(SQLB_RESOURCES
@@ -198,13 +233,44 @@
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_es_ES.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_fr.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_ru.ts"
+	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_pl.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_pt_BR.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_en_GB.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_ko_KR.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_tr.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_uk_UA.ts"
-)
-
+	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_it.ts"
+)
+
+# Windows image format plugin files
+set(WIN_IMG_PLUGINS
+	"${QT5_PATH}/plugins/imageformats/qgif.dll"
+	"${QT5_PATH}/plugins/imageformats/qicns.dll"
+	"${QT5_PATH}/plugins/imageformats/qico.dll"
+	"${QT5_PATH}/plugins/imageformats/qjpeg.dll"
+	"${QT5_PATH}/plugins/imageformats/qsvg.dll"
+	"${QT5_PATH}/plugins/imageformats/qtga.dll"
+	"${QT5_PATH}/plugins/imageformats/qtiff.dll"
+	"${QT5_PATH}/plugins/imageformats/qwbmp.dll"
+	"${QT5_PATH}/plugins/imageformats/qwebp.dll"
+)
+set(WIN_IMG_PLUGINS_DEBUG
+	"${QT5_PATH}/plugins/imageformats/qgifd.dll"
+	"${QT5_PATH}/plugins/imageformats/qicnsd.dll"
+	"${QT5_PATH}/plugins/imageformats/qicod.dll"
+	"${QT5_PATH}/plugins/imageformats/qjpegd.dll"
+	"${QT5_PATH}/plugins/imageformats/qsvgd.dll"
+	"${QT5_PATH}/plugins/imageformats/qtgad.dll"
+	"${QT5_PATH}/plugins/imageformats/qtiffd.dll"
+	"${QT5_PATH}/plugins/imageformats/qwbmpd.dll"
+	"${QT5_PATH}/plugins/imageformats/qwebpd.dll"
+)
+
+# License files
+set(LICENSE_FILES
+	LICENSE
+	LICENSE-PLUGINS
+)
 
 qt5_wrap_ui(SQLB_FORM_HDR ${SQLB_FORMS})
 if(SQLB_TSS)
@@ -232,6 +298,8 @@
 	ELSE( MINGW )
 		set(SQLB_SRC ${SQLB_SRC} "${CMAKE_CURRENT_SOURCE_DIR}/src/winapp.rc")
 	ENDIF( MINGW )
+else()
+	set(LPTHREAD pthread)
 endif(WIN32)
 
 #enable version check for MacOS
@@ -291,9 +359,6 @@
 		${SQLB_RESOURCES_RCC}
 		${SQLB_MISC})
 
-qt5_use_modules(${PROJECT_NAME} Gui Widgets Network Test PrintSupport)
-set(QT_LIBRARIES "")
-
 add_dependencies(${PROJECT_NAME} qhexedit qcustomplot)
 if(NOT ANTLR2_FOUND)
     add_dependencies(${PROJECT_NAME} antlr)
@@ -313,10 +378,13 @@
     link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
 endif()
 
+set(QT_LIBS Qt5::Gui Qt5::Test Qt5::PrintSupport Qt5::Widgets Qt5::Network Qt5::Concurrent Qt5::Xml)
+
 target_link_libraries(${PROJECT_NAME}
 		qhexedit
 		qcustomplot
-		${QT_LIBRARIES}
+    ${LPTHREAD}
+    ${QT_LIBS}
 		${WIN32_STATIC_LINK}
 		${LIBSQLITE}
 		${ADDITIONAL_LIBS})
@@ -332,6 +400,7 @@
 endif()
 
 if(WIN32 AND MSVC)
+	set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "DB Browser for SQLite")
 	set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_DEBUG "/SUBSYSTEM:CONSOLE")
 	set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_DEFINITIONS_DEBUG "_CONSOLE")
 	set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELWITHDEBINFO "/SUBSYSTEM:CONSOLE")
@@ -340,79 +409,3 @@
         set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS,5.02 /ENTRY:mainCRTStartup")
         set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:WINDOWS,5.02")
     else()
-        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS,5.01 /ENTRY:mainCRTStartup")
-        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:WINDOWS,5.01")
-    endif()
-endif()
-
-if(NOT WIN32)
-	install(TARGETS ${PROJECT_NAME}
-		RUNTIME DESTINATION bin
-		LIBRARY DESTINATION lib)
-endif()
-
-if(ENABLE_TESTING)
-	add_subdirectory(src/tests)
-endif()
-
-if(UNIX AND NOT APPLE)
-	install(FILES src/icons/${PROJECT_NAME}.png
-		DESTINATION share/icons/hicolor/256x256/apps/)
-	
-	install(FILES distri/${PROJECT_NAME}.desktop
-		DESTINATION share/applications/)
-
-	install(FILES distri/${PROJECT_NAME}.desktop.appdata.xml
-		DESTINATION share/appdata/)
-endif(UNIX AND NOT APPLE)
-
-if(WIN32 AND MSVC)
-	install(TARGETS ${PROJECT_NAME}
-		RUNTIME DESTINATION "/"
-		LIBRARY DESTINATION lib)
-
-	set(QT5_BIN_PATH ${QT5_PATH}/bin)
-	# The Qt5 Debug configuration library files have a 'd' postfix
-	install(FILES
-			${QT5_BIN_PATH}/Qt5Cored.dll
-			${QT5_BIN_PATH}/Qt5Guid.dll
-			${QT5_BIN_PATH}/Qt5Networkd.dll
-			${QT5_BIN_PATH}/Qt5PrintSupportd.dll
-			${QT5_BIN_PATH}/Qt5Widgetsd.dll
-		DESTINATION "/"
-		CONFIGURATIONS Debug)
-	# The Qt5 Release configuration files don't have a postfix
-	install(FILES
-			${QT5_BIN_PATH}/Qt5Core.dll
-			${QT5_BIN_PATH}/Qt5Gui.dll
-			${QT5_BIN_PATH}/Qt5Network.dll
-			${QT5_BIN_PATH}/Qt5PrintSupport.dll
-			${QT5_BIN_PATH}/Qt5Widgets.dll
-		DESTINATION "/"
-		CONFIGURATIONS Release)
-	# The files below are common to all configurations
-	install(FILES
-			${SQLITE3_DLL}
-			${OPENSSL_PATH}/libeay32.dll
-			${OPENSSL_PATH}/ssleay32.dll
-		DESTINATION "/")
-	install(FILES
-		${QT5_PATH}/plugins/platforms/qwindows.dll
-		DESTINATION platforms)
-	install(PROGRAMS "${VSREDIST_DIR}/${VSREDIST}" DESTINATION redist)
-	# The batch file launcher
-	install(FILES
-			distri/winlaunch.bat
-		DESTINATION "/")
-endif()
-
-#cpack
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "DB Browser for SQLite")
-set(CPACK_PACKAGE_VENDOR "DB Browser for SQLite Team")
-set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
-set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
-set(CPACK_PACKAGE_VERSION_MAJOR "3")
-set(CPACK_PACKAGE_VERSION_MINOR "10")
-set(CPACK_PACKAGE_VERSION_PATCH "1")
-set(CPACK_PACKAGE_INSTALL_DIRECTORY "DB Browser for SQLite")
-if(WIN32 AND NOT UNIX)

=== libs/antlr-2.7.7/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12.2)

set(ANTLR_SRC
		src/ANTLRUtil.cpp
		src/ASTFactory.cpp
		src/ASTNULLType.cpp
		src/ASTRefCount.cpp
		src/BaseAST.cpp
		src/BitSet.cpp
		src/CharBuffer.cpp
		src/CharScanner.cpp
		src/CommonAST.cpp
		src/CommonASTWithHiddenTokens.cpp
		src/CommonHiddenStreamToken.cpp
		src/CommonToken.cpp
		src/InputBuffer.cpp
		src/LLkParser.cpp
		src/MismatchedCharException.cpp
		src/MismatchedTokenException.cpp
		src/NoViableAltException.cpp
		src/NoViableAltForCharException.cpp
		src/Parser.cpp
		src/RecognitionException.cpp
		src/String.cpp
		src/Token.cpp
		src/TokenBuffer.cpp
		src/TokenRefCount.cpp
		src/TokenStreamBasicFilter.cpp
		src/TokenStreamHiddenTokenFilter.cpp
		src/TokenStreamRewriteEngine.cpp
		src/TokenStreamSelector.cpp
		src/TreeParser.cpp
		)

set(ANTLR_HDR
		antlr/ANTLRException.hpp
		antlr/ANTLRUtil.hpp
		antlr/AST.hpp
		antlr/ASTArray.hpp
		antlr/ASTFactory.hpp
		antlr/ASTNULLType.hpp
		antlr/ASTPair.hpp
		antlr/ASTRefCount.hpp
		antlr/BaseAST.hpp
		antlr/BitSet.hpp
		antlr/CharBuffer.hpp
		antlr/CharInputBuffer.hpp
		antlr/CharScanner.hpp
		antlr/CharStreamException.hpp
		antlr/CharStreamIOException.hpp
		antlr/CircularQueue.hpp
		antlr/CommonAST.hpp
		antlr/CommonASTWithHiddenTokens.hpp
		antlr/CommonHiddenStreamToken.hpp
		antlr/CommonToken.hpp
		antlr/IOException.hpp
		antlr/InputBuffer.hpp
		antlr/LLkParser.hpp
		antlr/LexerSharedInputState.hpp
		antlr/MismatchedCharException.hpp
		antlr/MismatchedTokenException.hpp
		antlr/NoViableAltException.hpp
		antlr/NoViableAltForCharException.hpp
		antlr/Parser.hpp
		antlr/ParserSharedInputState.hpp
		antlr/RecognitionException.hpp
		antlr/RefCount.hpp
		antlr/SemanticException.hpp
		antlr/String.hpp
		antlr/Token.hpp
		antlr/TokenBuffer.hpp
		antlr/TokenRefCount.hpp
		antlr/TokenStream.hpp
		antlr/TokenStreamBasicFilter.hpp
		antlr/TokenStreamException.hpp
		antlr/TokenStreamHiddenTokenFilter.hpp
		antlr/TokenStreamIOException.hpp
		antlr/TokenStreamRecognitionException.hpp
		antlr/TokenStreamRetryException.hpp
		antlr/TokenStreamRewriteEngine.hpp
		antlr/TokenStreamSelector.hpp
		antlr/TokenWithIndex.hpp
		antlr/TreeParser.hpp
		antlr/TreeParserSharedInputState.hpp
		antlr/config.hpp
		)

include_directories(.)

add_library(antlr ${ANTLR_SRC} ${ANTLR_HDR})

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,24 @@
 include_directories("${CMAKE_CURRENT_BINARY_DIR}" ..)
+
+if(NOT WIN32)
+	set(LPTHREAD pthread)
+endif()
 
 # test-sqlobjects
 
 set(TESTSQLOBJECTS_SRC
     ../sqlitedb.cpp
     ../sqlitetablemodel.cpp
+    ../RowLoader.cpp
     ../sqlitetypes.cpp
     ../csvparser.cpp
     ../grammar/Sqlite3Lexer.cpp
     ../grammar/Sqlite3Parser.cpp
     ../Settings.cpp
     testsqlobjects.cpp
+    ../Data.cpp
+    ../CipherSettings.cpp
+    ../DotenvFormat.cpp
 )
 
 set(TESTSQLOBJECTS_HDR
@@ -18,6 +26,7 @@
     ../grammar/Sqlite3Lexer.hpp
     ../grammar/Sqlite3Parser.hpp
     ../sqlitetypes.h
+    ../Data.h
 )
 
 set(TESTSQLOBJECTS_MOC_HDR
@@ -25,6 +34,8 @@
     ../sqlitetablemodel.h
     ../Settings.h
     testsqlobjects.h
+    ../CipherSettings.h
+    ../DotenvFormat.h
 )
 
 if(sqlcipher)
@@ -37,7 +48,9 @@
 
 add_executable(test-sqlobjects ${TESTSQLOBJECTS_MOC} ${TESTSQLOBJECTS_HDR} ${TESTSQLOBJECTS_SRC} ${TESTSQLOBJECTS_FORM_HDR})
 
-qt5_use_modules(test-sqlobjects Test Widgets Gui)
+find_package(Qt5 REQUIRED COMPONENTS Test Widgets Gui)
+target_link_libraries(test-sqlobjects Qt5::Test Qt5::Widgets Qt5::Gui)
+
 set(QT_LIBRARIES "")
 
 if(NOT ANTLR2_FOUND)
@@ -49,9 +62,7 @@
 else()
     target_link_libraries(test-sqlobjects antlr)
 endif()
-link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
-add_dependencies(test-sqlobjects qscintilla2)
-target_link_libraries(test-sqlobjects qscintilla2)
+target_link_libraries(test-sqlobjects ${LPTHREAD})
 add_test(test-sqlobjects test-sqlobjects)
 
 # test-import
@@ -67,7 +78,9 @@
 
 add_executable(test-import ${TESTIMPORT_MOC} ${TESTIMPORT_SRC})
 
-qt5_use_modules(test-import Test Core)
+find_package(Qt5 REQUIRED COMPONENTS Core)
+target_link_libraries(test-import Qt5::Test Qt5::Core)
+
 set(QT_LIBRARIES "")
 
 target_link_libraries(test-import ${QT_LIBRARIES})
@@ -78,11 +91,15 @@
 set(TESTREGEX_SRC
     ../sqlitedb.cpp
     ../sqlitetablemodel.cpp
+    ../RowLoader.cpp
     ../sqlitetypes.cpp
     ../grammar/Sqlite3Lexer.cpp
     ../grammar/Sqlite3Parser.cpp
     ../Settings.cpp
     TestRegex.cpp
+    ../Data.cpp
+    ../CipherSettings.cpp
+    ../DotenvFormat.cpp
 )
 
 set(TESTREGEX_HDR
@@ -90,6 +107,7 @@
     ../grammar/Sqlite3Lexer.hpp
     ../grammar/Sqlite3Parser.hpp
     ../sqlitetypes.h
+    ../Data.h
 )
 
 set(TESTREGEX_MOC_HDR
@@ -97,6 +115,8 @@
     ../sqlitetablemodel.h
     ../Settings.h
     TestRegex.h
+    ../CipherSettings.h
+    ../DotenvFormat.h
 )
 
 if(sqlcipher)
@@ -106,7 +126,8 @@
 
 add_executable(test-regex ${TESTREGEX_MOC} ${TESTREGEX_HDR} ${TESTREGEX_SRC})
 
-qt5_use_modules(test-regex Test Core Gui Widgets)
+target_link_libraries(test-regex Qt5::Test Qt5::Core Qt5::Gui Qt5::Widgets)
+
 set(QT_LIBRARIES "")
 
 if(NOT ANTLR2_FOUND)
@@ -118,7 +139,24 @@
 else()
     target_link_libraries(test-regex antlr)
 endif()
-link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
-add_dependencies(test-regex qscintilla2)
-target_link_libraries(test-regex qscintilla2)
+target_link_libraries(test-regex ${LPTHREAD})
 add_test(test-regex test-regex)
+
+# test cache
+
+set(TESTCACHE_SRC
+    TestRowCache.cpp
+)
+
+set(TESTCACHE_MOC_HDR
+    TestRowCache.h
+)
+
+add_executable(test-cache ${TESTCACHE_MOC} ${TESTCACHE_SRC})
+
+target_link_libraries(test-cache Qt5::Test Qt5::Core)
+
+set(QT_LIBRARIES "")
+
+target_link_libraries(test-cache ${QT_LIBRARIES})
+add_test(test-cache test-cache)

=== libs/qscintilla/Qt4Qt5/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,13 @@
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 2.8.12.2)
 
-set(CMAKE_AUTOMOC ON)
+# Disable AUTOMOC because it cannot be made to work with QScintilla
+set(CMAKE_AUTOMOC OFF)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
-find_package(Qt5Widgets REQUIRED)
+
+find_package(Qt5 REQUIRED COMPONENTS PrintSupport Widgets)
 
 if(APPLE)
-    find_package(Qt5MacExtras)
+    find_package(Qt5 REQUIRED COMPONENTS MacExtras)
 endif()
 
 add_definitions(-DSCINTILLA_QT)
@@ -22,6 +24,12 @@
 	qscilexer.cpp
 	qscilexercustom.cpp
 	qscilexersql.cpp
+	qscilexerjson.cpp
+	qscilexerhtml.cpp
+	qscilexerxml.cpp
+	qscilexerjavascript.cpp
+	qscilexercpp.cpp
+	qscilexerpython.cpp
 	qscimacro.cpp
 	qsciprinter.cpp
 	qscistyle.cpp
@@ -33,6 +41,8 @@
 	PlatQt.cpp
 	ScintillaQt.cpp
 	../lexers/LexSQL.cpp
+	../lexers/LexJSON.cpp
+	../lexers/LexHTML.cpp
 	../lexlib/Accessor.cpp
 	../lexlib/CharacterCategory.cpp
 	../lexlib/CharacterSet.cpp
@@ -143,17 +153,25 @@
 	./Qsci/qscilexer.h
 	./Qsci/qscilexercustom.h
 	./Qsci/qscilexersql.h
+	./Qsci/qscilexerjson.h
+	./Qsci/qscilexerhtml.h
+	./Qsci/qscilexerxml.h
+	./Qsci/qscilexerjavascript.h
+	./Qsci/qscilexercpp.h
+	./Qsci/qscilexerpython.h
 	./Qsci/qscimacro.h
 	SciClasses.h
 	ScintillaQt.h
 )
 
+QT5_WRAP_CPP(QSCINTILLA_WRAP_MOC_HDR ${QSCINTILLA_MOC_HDR})
+
 include_directories(. ../include ../lexlib ../src)
 
-add_library(qscintilla2 ${QSCINTILLA_SRC} ${QSCINTILLA_HDR} ${QSCINTILLA_MOC_HDR} ${QSCINTILLA_MOC})
+add_library(qscintilla2 ${QSCINTILLA_SRC} ${QSCINTILLA_HDR} ${QSCINTILLA_MOC_HDR} ${QSCINTILLA_MOC} ${QSCINTILLA_WRAP_MOC_HDR})
+
+target_link_libraries(qscintilla2 Qt5::Widgets Qt5::PrintSupport)
 
 if (APPLE)
-	qt5_use_modules(qscintilla2 Widgets PrintSupport MacExtras)
-else()
-	qt5_use_modules(qscintilla2 Widgets PrintSupport)
+	target_link_libraries(qscintilla2 Qt5::MacExtras)
 endif()

=== debian/changelog ===
sqlitebrowser (3.11.2-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:26:11 +0100

sqlitebrowser (3.11.2-1build1) focal; urgency=medium

  * No-change rebuild against libqscintilla2-qt5-15.

 -- Rik Mills <rikmills@kde.org>  Thu, 21 Nov 2019 09:53:02 +0000

sqlitebrowser (3.11.2-1) unstable; urgency=medium

  * New upstream version
  * Remove patch 0002, applied upstream.
  * Refresh the system libraries patch
  * Update to debhelper 12
  * Bump Standards-Version to 4.4.0

 -- Arto Jantunen <viiru@debian.org>  Sun, 28 Jul 2019 14:50:58 +0300

sqlitebrowser (3.10.1-2) unstable; urgency=medium

  * Point VCS urls to Salsa
  * Update system qscintilla2 library names
  * Bump Standards-Version to 4.1.5, no changes
  * Update to debhelper compat level 11
  * Enable all hardening options

 -- Arto Jantunen <viiru@debian.org>  Thu, 02 Aug 2018 21:10:47 +0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: database
 Priority: optional
 Maintainer: Arto Jantunen <viiru@debian.org>
-Build-Depends: debhelper (>= 10), qtbase5-dev, libsqlite3-dev, cmake, libantlr-dev, qttools5-dev, qttools5-dev-tools, libqscintilla2-qt5-dev
-Standards-Version: 4.1.1
+Build-Depends: debhelper-compat (= 12), qtbase5-dev, libsqlite3-dev, cmake, libantlr-dev, qttools5-dev, qttools5-dev-tools, libqt5scintilla2-dev
+Standards-Version: 4.4.0
 Homepage: http://sqlitebrowser.org/
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/sqlitebrowser.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/sqlitebrowser.git
+Vcs-Browser: https://salsa.debian.org/sqlitebrowser-team/sqlitebrowser
+Vcs-Git: https://salsa.debian.org/sqlitebrowser-team/sqlitebrowser.git
 
 Package: sqlitebrowser
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTING=True -DQSCINTILLA_INCLUDE_DIR=/usr/include/x86_64-linux-gnu/qt5/Qsci/
